// Thiw sample shows how to use Windows ClipBoard from FiveWin.

// To FiveWin, the ClipBoard is also an object!

#include "FiveWin.ch"

static oWnd, oClp

//----------------------------------------------------------------------------//

function Main()

   DEFINE WINDOW oWnd FROM 1, 1 TO 20, 70 ;
      TITLE "Using Windows ClipBoard" ;
      MENU BuildMenu()

   DEFINE CLIPBOARD oClp OF oWnd

   SET MESSAGE OF oWnd TO FWVERSION CENTERED

   ACTIVATE WINDOW oWnd

return nil

//----------------------------------------------------------------------------//

function BuildMenu()

   local oMenu

   MENU oMenu
      MENUITEM "&Using the ClipBoard"
      MENU
         MENUITEM "Place some text..." ;
            ACTION PlaceSomeText()

         MENUITEM "&Retrieve the text..." ;
            ACTION GetSomeText()

         SEPARATOR

         MENUITEM "&Clear the ClipBoard"  ACTION oClp:Clear()
         SEPARATOR
         MENUITEM "Bye, bye..."               ACTION oWnd:End()
      ENDMENU

      MENUITEM "Call ClipBoard management EXE" ACTION WinExec( "ClipBrd" )
   ENDMENU

return oMenu

//----------------------------------------------------------------------------//

function PlaceSomeText()

   local cText := Space( 30 )

   if MsgGet( "Ok...", "Write something!", @cText )
      oClp:SetText( cText )
   endif

return nil

//----------------------------------------------------------------------------//

function GetSomeText()

   local cText := oClp:GetText()

   if Empty( cText )
      nMsgBox( OemToAnsi( "There is nothing there!" ), "I am sorry" )
   else
      nMsgBox( cText, "Tadddaa !!!" )
   endif

return nil

//----------------------------------------------------------------------------//
