// Working with MDI enviroments

#include "FiveWin.ch"

static oWnd

//----------------------------------------------------------------------------//

function Main()

   local oWndEdit, oBar
   local cName := "FiveWin 1.8 power"

   DEFINE WINDOW oWnd FROM 1, 1 TO 20, 70 TITLE "Testing MDI" ;
      MDI ;
      MENU BuildMenu() // COLOR "GR+*/RB"

   SET MESSAGE OF oWnd TO "Main Window"

   DEFINE WINDOW oWndEdit MDICHILD OF oWnd FROM 2, 2 TO 20, 50 ;
      TITLE "I am a MDI Child" COLOR "W+/W"

   @ 4, 2 GET cName OF oWndEdit SIZE 170, 25 COLOR "BG+/B"

   DEFINE BUTTONBAR oBar OF oWndEdit

   DEFINE BUTTON OF oBar

   SET MESSAGE OF oWndEdit TO "Child Window"

   ACTIVATE WINDOW oWnd MAXIMIZED ;
      VALID MsgYesNo( "Want to End ?" )

return nil

//----------------------------------------------------------------------------//

function BuildMenu()

   local oMenu

   MENU oMenu
      MENUITEM "&Information"
      MENU
         MENUITEM "&About..." ACTION MsgAbout( "FiveWin", "FiveTech" )
         SEPARATOR
         MENUITEM "&End..." ACTION oWnd:End()
      ENDMENU

      MENUITEM "&Child Windows"
      MENU
         MENUITEM "&Tiled" ACTION oWnd:Tile()
         MENUITEM "&Cascade" ACTION oWnd:Cascade()
      ENDMENU
   ENDMENU

return oMenu

//----------------------------------------------------------------------------//
