// Testing the new FiveWin OBJECTS engine: User Defined error handler!

// Basicly, this new feature of OBJECTS engine lets you take the control
// when an error ocurrs managing an Object.

// You can define an Error handler on each Class. Once the error ocurrs
// you can take the control or you just can generate an ordinary error.

// This feature is extremelly powerfull for adding extra functionality
// to certain Classes. Basically, you can have same Class Objects with
// different behaviors without having to inherit new classes.

// The goal is to offer you more control with less coding !!!!

#include "FiveWin.ch"

//----------------------------------------------------------------------------//

function Main()

   local oTest := TTest():New()

   oTest:XXX()

return nil

//----------------------------------------------------------------------------//

CLASS TTest

   DATA dummy

   METHOD New() CONSTRUCTOR

   ERROR HANDLER Error( cMsg, nError )

ENDCLASS

//----------------------------------------------------------------------------//

METHOD New() CLASS TTest

   ::dummy = "This is just a test"

return Self

//----------------------------------------------------------------------------//

METHOD Error( cMsg, nError )

   MsgInfo( "Hey! Someone wants to issue a " + cMsg + ;
            " message on an Object of this Class" )

   if ! MsgYesNo( "Do we let him continue ?" )
      _ClsSetError( _GenError( nError, ::ClassName(), cMsg ) )
   endif

return nil

//----------------------------------------------------------------------------//
