**    Last revision: April 11, 1995 at 10:52

// This is an example of how to place controls inside a MDIChild


#include "FiveWin.ch"
#include "TCBrowse.ch"

static oWnd

//----------------------------------------------------------------------------//

function Main()

   local oBar

   SET 3DLOOK ON

   DEFINE WINDOW oWnd TITLE "MDI Child Container" MDI

   DEFINE BUTTONBAR oBar 3D OF oWnd

   DEFINE BUTTON OF oBar ACTION Child()

   SET MESSAGE OF oWnd TO "Press Button to Test Resizable "+ ;
      "TCBrowse in MDI Windows"  CENTERED TIME DATE KEYBOARD

   ACTIVATE WINDOW oWnd

return nil

//----------------------------------------------------------------------------//

function dummy()
return nil

//----------------------------------------------------------------------------//

function Child()


   local oWndChild, oBrw, oFont
   local nI, aTestData

   DEFINE WINDOW oWndChild MDICHILD OF oWnd ;
     FROM 10, 50 TO 250, 400 PIXEL  COLOR "N/W"

   CursorWait()

   // load some fields into a multi element array,    
   USE TestTcb2                        // or some other way to...
   aTestData := Array( LastRec(), RecCount() )  // make the array
   FOR nI := 1 TO Len(aTestData)
     aTestData[nI,1] := Field->Salary   // numb
     aTestData[nI,2] := PadR(Trim(Field->First)+ " "+Trim(Field->Last), 50)
     // need to pad char array element for editing beyond last character
     aTestData[nI,3] := Field->Married  // logical
     aTestData[nI,4] := Field->HireDate // date
     aTestData[ nI, 5 ] = FieldGet( 5 )
     IF .NOT.EOF()
       SKIP
     ENDIF
   NEXT

   // USE

   DEFINE FONT oFont NAME "Arial" SIZE 6, 15 BOLD

   @ 1.5, 1 COLUMN BROWSE oBrw OF oWndChild ; // FONT oFont ;
     ON LEFT DBLCLICK EditCell( oBrw, nRow, nCol ) ;
     SIZE 180, 135 MESSAGE "Multi-Element Array Column Browse - "+ ;
                           "DblClick to Edit an Entry"

   oBrw:SetArray( aTestData )

   oBrw:nClrForeHead := CLR_WHITE
   oBrw:nClrBackHead := CLR_BLUE

   // oBrw:bLDblClick = { | nRow, nCol | EditCell( oBrw, nRow, nCol ) }
   // oBrw:lNoLiteBar := .t.  // get rid of the lite bar cursor
   // oBrw:lNoGrayBar := .t.  // get rid of that ugly gray bar on lost focus
   // oBrw:lMChange   := .t.  // set false to prevent Mouse colm resize/drag

   //oBrw:lLogicDrop := .t.  // use crazy logic dropbox
   //oBrw:lNoHScroll := .t.  // don't use that pesky horiz scroll bar
   //oBrw:nAdjColumn :=  3   // expand this column to flush table right
   //oBrw:nFreeze    :=  5   // This will freeze all & prevent horiz scrolling
                           // NOTE can't resize/drag on frozen columns

   oBrw:hBmpCursor := ReadBitmap( 0, "Triangle.bmp" )

   ADD COLUMN TO BROWSE oBrw  DATA "" SIZE 15 // Empty Colm for BmpCursor

   ADD COLUMN TO BROWSE oBrw  DATA oBrw:nAt ; // the array element number
     SIZE 30 NOBAR CENTER COLOR CLR_BLACK, CLR_HGRAY ;
     HEADER "No"

   ADD COLUMN TO oBrw DATA ARRAY ELEM 1 ;     // array element # 1
     HEADER "Salary  "  SIZE 60 PICTURE "999,999" RIGHT ;
     EDITABLE

   ADD TO oBrw ARRAY ELM 2 ;
     HEADER  "   Name"  EDIT MESSAGE "First and Last Names" ;
     SIZE 120 PICTURE "@S50"  // make narrow but use sliding edit 

   ADD COLUMN TO oBrw ARRAY ELEM 3 ;
     HEADER  "Log"   SIZE 30 CENTER ;
     MESSAGE "Married is this Logical Variable"  PICT "Y" ;
     EDIT VALID IF x == .t. ; // "Yes" ;    // VALID IF returns var as 'x'
     ERROR MESSAGE "Only True is allowed"

   ADD COLUMN TO oBrw DATA ARRAY ELEMENT 4 ;   // damn, spell how many ways 
     HEADER  "HireDate" SIZE 65 PICTURE "@D" CENTER ;
     MESSAGE "His hire date" ;
     EDIT VALID IF x < CtoD("12/31/93") .and. x > CtoD("12/31/90")  ;
     ERROR MSG "Date must be between"+CRLF+"12/31/90 and 12/31/93"

   
   oWndChild:SetControl( oBrw ) 

   ACTIVATE WINDOW oWndChild 


return nil

//----------------------------------------------------------------------------//
