// Developed by Ignacio Ortiz de Zuiga

#include <WinTen.h>
#include <Windows.h>
#include <ClipApi.h>

//---------------------------------------------------------------------------//

CLIPPER DitBackGrd() // hWnd, hDC, nRed, nGreen, nBlue
{
    HWND hWnd      = _parni( 1 );
    HDC hDC        = _parni( 2 );
    BYTE nRed      = _parni( 3 );
    BYTE nGreen    = _parni( 4 );
    BYTE nBlue     = _parni( 5 );
    RECT rct;
    HBRUSH hBrush;
    BYTE nBStep, nGStep, nRStep;
    WORD nStep, nFor;

    GetClientRect( hWnd, &rct );

    nStep  = (rct.bottom - rct.top) / 3;
    nRStep = MAX(nRed / nStep, 1);
    nGStep = MAX(nGreen / nStep, 1);
    nBStep = MAX(nBlue / nStep, 1);

    rct.bottom = 0;

    for( nFor = 1; nFor <= nStep; nFor++ )
    {
      rct.bottom += 3;

      hBrush = CreateSolidBrush(RGB(nRed, nGreen, nBlue));
      FillRect( hDC, &rct, hBrush );
      DeleteObject(hBrush);

      rct.top += 3;

      if( nRed   > 10 ) nRed   = MAX( 10, nRed - nRStep );
      if( nGreen > 10 ) nGreen = MAX( 10, nGreen - nGStep );
      if( nBlue  > 10 ) nBlue  = MAX( 10, nBlue - nBStep );
    }
}
