// How to use folders and manipulate them at run-time!

#include "FiveWin.ch"
#include "Folder.ch"

static oWnd, oFld

//----------------------------------------------------------------------------//

function Main()

   local cTemp

   DEFINE WINDOW oWnd TITLE "Folders generation" COLOR "N/W"

   @ 1, 1 FOLDER oFld ITEMS "&One", "&Two", "T&hree" ;
      OF oWnd

   @ 5, 2 BUTTON "&Add" OF oFld SIZE 70, 25 ;
      ACTION oFld:AddItem( "&NewTab" )

   @ 8, 2 BUTTON "&Edit" OF oFld SIZE 70, 25 ;
      ACTION ( cTemp := PadR( oFld:aPrompts[ oFld:nOption ], 40 ),;
               MsgGet( "Edit", "Tab prompt", @cTemp ),;
               oFld:aPrompts[ oFld:nOption ] := AllTrim( cTemp ),;
               oFld:Refresh() )

   @ 11, 2 BUTTON "&Del" OF oFld SIZE 70, 25 ;
      ACTION oFld:DelItem()

   @ 14, 2 BUTTON "&Gen" OF oFld SIZE 70, 25 ;
      ACTION cGetFile( "*.rc", "RC to generate" )

   ACTIVATE WINDOW oWnd ;
      ON RESIZE FoldResize()

return nil

//----------------------------------------------------------------------------//

function FoldResize()

  local oRect := oWnd:GetCliRect()

  oFld:Move( 8, 8, oRect:nRight - oRect:nLeft - 16,;
             oRect:nBottom - oRect:nTop - 16, .t. )

return nil

//----------------------------------------------------------------------------//
