#include "FiveWin.ch"

//----------------------------------------------------------------------------//

function Main()

   local oDlg, oLbx1, oLbx2, oCbx1, oCbx2
   local cItem1 := "Drive A:", cItem2 := "Drive C:", cItem3, cItem4

   SET 3DLOOK ON

   DEFINE DIALOG oDlg RESOURCE "Test"

   REDEFINE LISTBOX oLbx1 VAR cItem1 ;
      ID 110 OF oDlg ;
      ITEMS   { "Drive A:", "Drive C:", "Ram Drive", "Net Drive" } ;
      BITMAPS { "..\bitmaps\fdrive.bmp",;
                "..\bitmaps\hdrive.bmp",;
                "..\bitmaps\ramdrive.bmp",;
                "..\bitmaps\netdrive.bmp" }

   REDEFINE COMBOBOX oCbx1 VAR cItem2 ;
      ID 120 OF oDlg ;
      ITEMS   { "Drive A:", "Drive C:", "Ram Drive", "Net Drive" } ;
      BITMAPS { "..\bitmaps\fdrive.bmp",;
                "..\bitmaps\hdrive.bmp",;
                "..\bitmaps\ramdrive.bmp",;
                "..\bitmaps\netdrive.bmp" }

   REDEFINE LISTBOX oLbx2 VAR cItem3 ;
      ID 130 OF oDlg ;
      FILES "*.*" ;
      BITMAPS { "..\bitmaps\sFolder.bmp",;
                "..\bitmaps\sExe.bmp",;
                "..\bitmaps\sPrg.bmp",;
                "..\bitmaps\sBat.bmp" } ;
      ON DRAWITEM SelectBitmap( nItem, oLbx2 )

   REDEFINE COMBOBOX oCbx2 VAR cItem4 ;
      ID 140 OF oDlg ;
      ITEMS   { "White", "Blue", "Red", "Yellow", "Green" } ;
      BITMAPS { "..\bitmaps\sWhite.bmp",;
                "..\bitmaps\sBlue.bmp",;
                "..\bitmaps\sRed.bmp",;
                "..\bitmaps\sYellow.bmp",;
                "..\bitmaps\sGreen.bmp" }

   ACTIVATE DIALOG oDlg CENTERED

return nil

//----------------------------------------------------------------------------//

function SelectBitmap( nItem, oLbx2 )

   local cExtension := Right( oLbx2:aItems[ nItem ], 3 )
   local nBitmap    := 1

   do case
      case cExtension == "exe"
           nBitmap = 2

      case cExtension == "prg"
           nBitmap = 3

      case cExtension == "bat"
           nBitmap = 4
   endcase

return nBitmap

//----------------------------------------------------------------------------//
