// Sample showing how to detect Dialog focused control

#include "FiveWin.ch"

static oDlgActive

//----------------------------------------------------------------------------//

function Main()

   local oDlg
   local cOne   := "I am the first"
   local cTwo   := "I am the second"
   local cThree := "I am the third"
   local cFour  := "I am the fourth"

   SET 3DLOOK ON

   SetKey( VK_F2, { || CtrlSearch() } )

   DEFINE DIALOG oDlg TITLE "Searching focus..." FROM 2, 2 TO 20, 50

   @ 2, 2 GET cOne   OF oDlg
   @ 4, 2 GET cTwo   OF oDlg
   @ 6, 2 GET cThree OF oDlg
   @ 8, 2 GET cFour  OF oDlg

   oDlgActive = oDlg

   ACTIVATE DIALOG oDlg CENTERED

return nil

//----------------------------------------------------------------------------//

function CtrlSearch()

   local nAt := AScan( oDlgActive:aControls, { | oCtrl | oCtrl:lFocused } )

   MsgInfo( nAt )

return nil

//----------------------------------------------------------------------------//
