// Small sample showing how to request a password previous to main window

#include "FiveWin.ch"

static oWnd

//----------------------------------------------------------------------------//

function Main()

   if lGetPassword()

      DEFINE WINDOW oWnd TITLE "Main"

      ACTIVATE WINDOW oWnd ;
         VALID MsgYesNo( "Want to end ?" )
   endif

return nil

//----------------------------------------------------------------------------//

function lGetPassword()

   local oDlg, oGet
   local cPassword := Space( 10 )
   local nTries    := 0
   local lGo       := .f.

   DEFINE DIALOG oDlg ;
      FROM 5, 5 TO 20, 50 ;
      TITLE "Please Identify"

   @ 1, 2 SAY "Write FiveWin to go ahead..." OF oDlg
   @ 2, 2 GET oGet VAR cPassword OF oDlg PASSWORD

   @ 5, 5 BUTTON "&Continue" OF oDlg ;
      ACTION ( nTries++,;
               lGo := Upper( AllTrim( cPassword ) ) == "FIVEWIN",;
               If( nTries > 3 .or. lGo, oDlg:End(),;
                   ( MsgAlert( "Wrong password!" ), oGet:SetFocus() ) ) )

   ACTIVATE DIALOG oDlg CENTERED

return lGo

//----------------------------------------------------------------------------//
