// Inspecting the Windows API msgs. Just for advanced users!

#include "FiveWin.ch"

//----------------------------------------------------------------------------//

function Main()

   local oWnd

   // Windows msgs inspector
   WinInspect( { | hWnd, nMsg, nWParam, nLParam | ;
               Inspect( hWnd, nMsg, nWParam, nLParam ) } )

   DEFINE WINDOW oWnd FROM 3, 6 TO 20, 70 ;
      TITLE "Wellcome to FiveWin" ;
      COLOR "W+*/R"
      
   @ 2, 2 SAY "Hello" OF oWnd

   ACTIVATE WINDOW oWnd

return nil

//----------------------------------------------------------------------------//

function Inspect( hWnd, nMsg, nWParam, nLParam )

   static lInit := .f.

   if ! lInit
      lInit = .t.
      if ! File( "Msgs.dbf" )
         DbCreate( "Msgs", { { "hWnd",    "N", 15, 0 },;
                             { "nMsg",    "N", 15, 0 },;
                             { "nWParam", "N", 15, 0 },;
                             { "nLParam", "N", 15, 0 } } )
      endif
      USE Msgs
      ZAP
   endif

   APPEND BLANK
   Msgs->hWnd    := hWnd
   Msgs->nMsg    := nMsg
   Msgs->nWParam := nWParam
   Msgs->nLParam := nLParam

return nil

//----------------------------------------------------------------------------//
