#include "FiveWin.ch"

#define IDC_SIZENWSE  32642
#define IDC_SIZENESW  32643
#define IDC_SIZEWE    32644
#define IDC_SIZENS    32645

//----------------------------------------------------------------------------//

CLASS TCursor

   DATA   hCursor
   DATA   lPredef

   METHOD New( cResName, cPredef ) CONSTRUCTOR

   METHOD End() INLINE If( ::hCursor != 0,;
                       If( ! ::lPredef, DestroyCursor( ::hCursor ),),),;
                           ::hCursor := 0
ENDCLASS

//----------------------------------------------------------------------------//

METHOD New( cResName, cPredef ) CLASS TCursor

   if ! Empty( cPredef )
      do case
         case cPredef == "SIZEWE"
              ::hCursor = LoadCursor( 0, IDC_SIZEWE )

         case cPredef == "SIZENESW"
              ::hCursor = LoadCursor( 0, IDC_SIZENESW )

         case cPredef == "SIZENWSE"
              ::hCursor = LoadCursor( 0, IDC_SIZENWSE )

         case cPredef == "SIZENS"
              ::hCursor = LoadCursor( 0, IDC_SIZENS )

      endcase
      ::lPredef = .t.
   else
      ::hCursor = LoadCursor( GetResources(), cResName )
      ::lPredef = .f.
   endif

return nil

//----------------------------------------------------------------------------//
