// Under construction - not available yet!

#include "FiveWin.CH"

//----------------------------------------------------------------------------//

CLASS TDbf

   DATA   cName, cAlias, lShared, cComments
   DATA   aFields, aIndexes

   METHOD New( cName, cAlias, lShared, cComments) CONSTRUCTOR

   METHOD Import( cDbfFile ) CONSTRUCTOR

   METHOD Create( cPath )

ENDCLASS

//----------------------------------------------------------------------------//

METHOD New( cName, cAlias, lShared, cComments ) CLASS TDbf

   ::cName     = cName
   ::cAlias    = cAlias
   ::lShared   = lShared
   ::cComments = cComments
   ::aFields   = {}
   ::aIndexes  = {}

return nil

//----------------------------------------------------------------------------//

METHOD Create( cPath ) CLASS TDbf

   local aInfo := {}
   local n

   DEFAULT cPath := ""

   IF ! Empty( cPath )
      cPath += "\"
   ENDIF

   FOR n = 1 TO Len( ::aFields )
       AAdd( aInfo, { ::aFields[ n ]:cName,;
                      ::aFields[ n ]:cType,;
                      ::aFields[ n ]:nWidth,;
                      ::aFields[ n ]:nDecimal })
   NEXT


   DbCreate( cPath + ::cName, aInfo )

return nil

//----------------------------------------------------------------------------//

METHOD Import ( cDbfFile ) CLASS TDbf

   local aInfo
   local cArea := Select()
   local n

   if File( cDbfFile )
      USE ( cDbfFile ) NEW
      aInfo := DbStruct()
      USE
      Select( cArea )
   endif

   ::aFields   = {}
   ::cName     = SubStr( cDbfFile, RAt( "\", cDbfFile ) + 1 )
   ::cAlias    = ::cName
   ::cComments = ""

   if At( ".", ::cName ) != 0
      ::cName = SubStr( ::cName, 1, At( ".", ::cName ) - 1 )
      ::cAlias = ::cName
   endif

   for n := 1 to Len( aInfo )

       AAdd( ::aFields, TField():New( ::cName, n, .F.,;
                                      aInfo[ n ][ 1 ],;
                                      aInfo[ n ][ 2 ],;
                                      aInfo[ n ][ 3 ],;
                                      aInfo[ n ][ 4 ] ) )
   next

return nil

//----------------------------------------------------------------------------//
